Hot News:

Mit Unterstützung durch:

  Foren auf CAD.de (alle Foren)
  Lisp
  MTEXT mit entmake setzen

Antwort erstellen  Neues Thema erstellen
CAD.de Login | Logout | Profil | Profil bearbeiten | Registrieren | Voreinstellungen | Hilfe | Suchen

Anzeige:

Darstellung des Themas zum Ausdrucken. Bitte dann die Druckfunktion des Browsers verwenden. | Suche nach Beiträgen nächster neuer Beitrag | nächster älterer Beitrag
Autor Thema:   MTEXT mit entmake setzen (931 mal gelesen)
romi1
Mitglied
Bautechniker


Sehen Sie sich das Profil von romi1 an!   Senden Sie eine Private Message an romi1  Schreiben Sie einen Gästebucheintrag für romi1

Beiträge: 622
Registriert: 09.02.2006

Xeon E3-1245V2
16GB RAM
Windows 10 Professional 64 bit
AutoCAD 2014

erstellt am: 26. Mrz. 2010 11:36    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

Hallo!

Habe mir ein Lisp geschrieben, welche diverse Daten extrahiert und diese formatiert (mit Tabulatoren, ...) in die Variable "mtext-zeile" schreibt; diese Daten sollen dann zum Schluß als MTEXT mit entmake in die Zeichnung gesetzt werden:

Code:
  (entmake                                                                               
    (list
      (cons 0  "MTEXT")
      (cons 100  "AcDbEntity")
      (cons 100 "AcDbMText")
      (list '10 (car einsetzp) (cadr einsetzp))
      (cons 40 2.5)                                                                       
      (cons 41 250)
      (cons 1 mtext-zeile)
      (cons 50 0.0)
    )         
  )


Das funktioniert aber scheinbar nur dann, wenn die Variable "mtext-zeile" nicht zu viele Zeichen enthält. Wenn zu viele Zeichen in der Variable, wird einfach nichts ausgegeben - auch keine Fehlermeldung. Ich möchte aber auch längere Texte mit dieser Routine ausgeben; Wie kann ich das Problem beheben?

Gruß,
Roman

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

CADmium
Moderator
Maschinenbaukonstrukteur




Sehen Sie sich das Profil von CADmium an!   Senden Sie eine Private Message an CADmium  Schreiben Sie einen Gästebucheintrag für CADmium

Beiträge: 13435
Registriert: 30.11.2003

.

erstellt am: 26. Mrz. 2010 11:41    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für romi1 10 Unities + Antwort hilfreich

Erstell einfach mal mit dem MText-Befehl so einen MText mit mehr als 255 Zeichen. und dann schau dir die Rückgabe von (entget(car(entsel))) mit Anwahl dieses Mtextes an .. besonders auf die GC1 und die GC3  

... und dann passe deinen Code entsprechend an. (und poste ihn hier)

oder du guckst dir die entsprechenden activeX methoden an ... da ist es etwas enfacher ( Den Textstring zu setzen)
------------------
      - Thomas -          
"Bei 99% aller Probleme ist die umfassende Beschreibung des Problems bereits mehr als die Hälfte der Lösung desselben."

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

romi1
Mitglied
Bautechniker


Sehen Sie sich das Profil von romi1 an!   Senden Sie eine Private Message an romi1  Schreiben Sie einen Gästebucheintrag für romi1

Beiträge: 622
Registriert: 09.02.2006

Xeon E3-1245V2
16GB RAM
Windows 10 Professional 64 bit
AutoCAD 2014

erstellt am: 27. Mrz. 2010 14:07    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

Hallo!

Vielen Dank für den Tipp! Hab' das Lisp nun also folgendermaßen umgebaut, und es scheint zu funktionieren:

Code:
(setq li1                                                                               
    (list
      (cons 0  "MTEXT")
      (cons 100  "AcDbEntity")
      (cons 100 "AcDbMText")
      (list '10 (car einsetzp) (cadr einsetzp))
      (cons 40 2.5)                                                                       
      (cons 41 250)
      (cons 50 0.0)
    )
  )
  (if
    (< (strlen mtext-zeile) 250)
    (setq li2 (list (cons 1 mtext-zeile)))
    (progn
      (setq li2 ())
      (while
        (> (strlen mtext-zeile) 250)
        (setq li2        (cons (cons 3 (substr mtext-zeile 1 249)) li2)
              mtext-zeile (substr mtext-zeile 250)
        )
      )
      (setq li2 (reverse (cons (cons 1 mtext-zeile) li2)))
    )
  )
 
  (entmake (append li1 li2))

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Anzeige.:

Anzeige: (Infos zum Werbeplatz >>)

Darstellung des Themas zum Ausdrucken. Bitte dann die Druckfunktion des Browsers verwenden. | Suche nach Beiträgen

nächster neuerer Beitrag | nächster älterer Beitrag
Antwort erstellen


Diesen Beitrag mit Lesezeichen versehen ... | Nach anderen Beiträgen suchen | CAD.de-Newsletter

Administrative Optionen: Beitrag schliessen | Archivieren/Bewegen | Beitrag melden!

Fragen und Anregungen: Kritik-Forum | Neues aus der Community: Community-Forum

(c)2020 CAD.de | Impressum | Datenschutz